/*
**	exp3.c
*/
#include "mpeg.h"
#include "disp.h"
#define clip(t) ((t)<0)?0:((t)>255)?255:(t)
void
exp3f(int wx, int wy, Uc p[][wx], Uc q[][wx*3])
{
	int i,j,t;
	// horizontal
	for(j=0;j<wy;j++) {
		q[3*j][0]=  p[j][0];
		q[3*j][1]= (3*p[j][0]+p[j][1])>>2;
		q[3*j][2]= (p[j][0]+3*p[j][1])>>2;
		for(i=1;i<wx-2;i++) {
			q[3*j][3*i]= p[j][i];
			t= (15*p[j][i]+3*p[j][i+1]-2*p[j][i-1])>>4;
			q[3*j][3*i+1]= clip(t);
			t= (15*p[j][i+1]+3*p[j][i]-2*p[j][i+2])>>4;
			q[3*j][3*i+2]= clip(t);
		}
		q[3*j][3*wx-6]= q[3*j][3*wx-5]= q[3*j][3*wx-4]= p[j][wx-2];
		q[3*j][3*wx-3]= q[3*j][3*wx-2]= q[3*j][3*wx-1]= p[j][wx-1];
	}
	// vertical
	for(i=0;i<3*wx;i++) {
		q[2][i]= q[1][i]= (q[0][i]+q[2][i])>>1;
		for(j=1;j<wy-2;j++) {
			t= (15*q[3*j][i]+3*q[3*j+3][i]-2*q[3*j-3][i])>>4;
			q[3*j+1][i]= clip(t);
			t= (15*q[3*j+3][i]+3*q[3*j][i]-2*q[3*j+6][i])>>4;
			q[3*j+2][i]= clip(t);
		}
		q[3*wy-5][i]= q[3*wy-4][i]= (q[3*wy-3][i]+q[3*wy-6][i])>>1;
		q[3*wy-2][i]= q[3*wy-1][i]= q[3*wy-3][i];
	}
}
