/*
**	expf.c
*/

#include "mpeg.h"
#include "disp.h"
#define clip(t) ((t)>255)?255:((t)<0)?0:(t)
void
exp_f(int wx, int wy, Uc p[][wx], Uc q[][wx*2])
{
	int i,j,t;
	// horizontal
	for(j=0;j<wy;j++) {
		q[2*j][0]=  p[j][0];
		q[2*j][1]= (p[j][0]+p[j][1])>>1;
		for(i=1;i<wx-2;i++) {
			q[2*j][2*i]= p[j][i];
			t= (5*(p[j][i]+p[j][i+1])-p[j][i-1]-p[j][i+2])>>3;
			q[2*j][2*i+1]= clip(t);
		}
		q[2*j][2*wx-4]= q[2*j][2*wx-3]= p[j][wx-2];
		q[2*j][2*wx-2]= q[2*j][2*wx-1]= p[j][wx-1];
	}
	// vertical
	for(i=0;i<2*wx;i++) {
		q[1][i]= (q[0][i]+q[2][i])>>1;
		for(j=1;j<wy-2;j++) {
			t= (5*(q[2*j][i]+q[2*j+2][i])-q[2*j-2][i]-q[2*j+4][i])>>3;
			q[2*j+1][i]= clip(t);
		}
		q[2*wy-3][i]= (q[2*wy-2][i]+q[2*wy-4][i])>>1;
		q[2*wy-1][i]=  q[2*wy-2][i];
	}
}
