/*
**	sys.c	mpeg-1 system demux
#define Debug
*/
#include "mpeg.h"
#define BL 2048

int	prs= 0;
FILE	*bs;
char	ar[BL];
int	times= 1;

usage(p) char *p; {
fprintf(stderr, "Usage: %s [system bitstream]\n", p);
fprintf(stderr, "-:stdin, output:stdout \n");
fprintf(stderr, "-l:loop, -tN:times \n");
#ifdef Debug
fprintf(stderr, "-v:verbose, \n");
#endif
exit(1);
}

main(argc, argv)
int argc;
char **argv;
{
char *bsname;
char *p;
p= argv[0];

#ifdef Beta
unlink(p);
#endif

argc--; argv++;
bs= NULL;
while (argc) {
	if(strcmp(*argv,"-v")==0) prs= 1;
	else if (strncmp(*argv,"-t",2)==0) times= atoi(*argv+2);
	else if (strcmp(*argv,"-l")==0) times= 0;
	else if (strcmp(*argv,"-")==0){ bs= stdin; bsname= "stdin";}
	else if (**argv == '-') {
		fprintf(stderr, "unknown option: %s\n", *argv);
		usage(p);
		}
	else break;
	argc--; argv++;
	}
if(argc==0){ if (bs != stdin) usage(p); }
else {
	if(argc!=1) usage(p);
	bsname= *argv++;
	if ((bs = fopen(bsname,"r")) == NULL) {
		fprintf(stderr, "can't open %s\n",bsname);
		exit(1);
		}
	}
T: sys();
if(--times){ if(fseek(bs,0L,0))return 1; goto T; }
return 0;
}

#ifdef Debug
fp1(format) char *format; {
if(prs)fprintf(stderr,format);
}
fp2(format,arg1) char *format; {
if(pr)fprintf(stderr,format,arg1);
}
fp(format,arg1,arg2) char *format; {
if(pr)fprintf(stderr,format,arg1,arg2);
}
#else
#define fp1(a)
#define fp2(a,b)
#define fp(a,b,c)
#endif

start_code() { int t;
	do{
	  do{
	    do{ t= getc(bs); if(t==EOF)return 0xb9; } while(t);
	    t=getc(bs); if(t==EOF)return 0xb9;
	    } while(t);
	  do{ t=getc(bs); if(t==EOF)return 0xb9;
		} while(t==0);
	  }while(t-1);
t= getc(bs); if(t==EOF)t= 0xb9;
return t;
}

getnc(n){ do{ getc(bs); } while(--n); }
get2c(){ int t= getc(bs); return (t<<8|getc(bs)); }

sys() {
int len,t,w,l,n;
int stc= 0;
if((stc= start_code())<0xb9){
	ar[0]= 0; ar[1]= 0; ar[2]= 1; ar[3]= stc;
	n=fread(ar+4,1,BL-4,bs); fwrite(ar,1,n+4,stdout);
	while(n=fread(ar,1,BL,bs)) fwrite(ar,1,n,stdout);
	}
else goto IN;
while((stc= start_code())!=0xb9){
	IN:
	w= len= 0;
	if(stc==0xbf) fp1("private stream 2\n");
	else if(stc==0xba){ fp1("pack\n"); len= 8; }
	else if(stc==0xbb){ len= get2c(); fp2("shc len:%d\n",len); }
	else {	len= get2c();
		do { t= getc(bs); len--; }while(t==255);
		if((t>>(8-2))==1){ getc(bs); t= getc(bs); len-=2; }
		if((t>>(8-4))==2){ getnc(4); len-= 4; }
		else if((t>>(8-4))==3){ getnc(9); len-= 9; }
		if(stc>=0xe0&&stc<0xf0){ fp("video sid= %x pld:%d\n",stc,len); w= 1; }
		//if(stc>=0xc0&&stc<0xe0){ fp("audio sid= %x pld:%d\n",stc,len); w= 1; }
#ifdef Debug
		  else {
			if(stc>=0xc0&&stc<0xe0)fp2("audio sid= %x",stc);
			else if(stc==0xbd)fp1("private stream 1");
			else if(stc==0xbe)fp1("padding stream");
			else if((stc&0xf0)==0xf0)fp1("reserved stream");
			else fp2("??? %x", stc);
			fp2("len:%d\n",len);
			}
#endif
		}
	while(len){
		if(!(n=fread(ar,1,(len>BL)?BL:len,bs)))return;/*EOF!*/
		if(w)fwrite(ar,1,n,stdout);
		len-= n;
		}
	}
}
