/*
**	disp.h
*/
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#define SH_MEM

#ifdef SH_MEM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

#define	Max	0x7fffffff
#define NOS (176*120)
#define NOC 256		/* NOC: should be 2's power */
#define CN  256
#define ICN 32
#define GR  ICN

#ifdef BTL
#define TL (4096*8)
#else
#ifdef BTL2
#define TL (4096*4)
#else
#define TL 4096
#endif
#endif

#define FullColor 9

struct rgb{int r; int g; int b;};
typedef struct rgb Rgb;
extern Display *dpy;
extern Window w1;
extern GC gc;
extern Colormap map,dmap;
extern XColor c1;
extern XImage *xi;
extern char   *dd;
extern Clp Q;
extern Ui tbc[TL];
extern int my[CN];
extern int mu[CN];
extern int mv[CN];
extern int mc[CN];
extern int cmr[CN];
extern int cmg[CN];
extern int cmb[CN];
extern int winw,winh;
extern int wix,wiy;
extern int contrast,bright,cost,sint;
extern int dx,dy,ddx,ddy,xys;	/* display hs,vs,dhs,dvs,vhs */

#define Rgbrgb() y=(r+2*g+b)>>2; u= (b-y)>>1; v= (r-y)>>1;\
	aaa()

#define Yuvrgb() r= Q.cl[y+v*2]; g= Q.cl[y-u-v]; b= Q.cl[y+u*2];\
	cmr[j]= r; cmg[j]= g; cmb[j]= b;\
	aaa()

#define aaa() \
	if(cmp){\
		y= (contrast*y+bright)>>16;\
		u= (cost*u-sint*v)>>16;\
		v= (sint*u+cost*v)>>16;\
		}\
	y= ((y-16)*255)/219;\
	if(y>255)y=255;\
	u= (u*255)/224;\
	v= (v*255)/224;\
	r= y+1.402*v;\
	g= y-0.344*u-0.714*v;\
	b= y+1.772*u;\
	r= Q.cl[r]; g= Q.cl[g]; b= Q.cl[b];

